-------------------------------------------------
-- global vars & code
-------------------------------------------------

Equi_Notepad_PLAYERNAME = "";			-- current players name
Equi_Notepad_IGNORE_UPDATE = false;		-- used to prevent scroll bar updating when editbox text is set
Equi_Notepad_INITIALISED = 0;
Equi_Notepad_LDB = 0;
Equi_Notepad_Macro = 0;
EN_Note = "IMPORTANT NOTE FROM THE AUTHOR\n"
EN_Note = EN_Note .. "This addon has been superseded by my new feature rich notepad, NOTEWORTHY:\n"
EN_Note = EN_Note .. "http://equilibrium.kudosgames.com/addons/noteworthy.asp\n\n"

SLASH_NOTEPAD1, SLASH_NOTEPAD2 = '/notepad', '/notes';

-------------------------------------------------
-- event functions
-------------------------------------------------
function SlashCmdList.NOTEPAD(msg, editbox)
	Equi_NotepadToggleView();
end

function Checkbutton_OnLoad(checkButton)
	-- set label on check button
    _G[checkButton:GetName() .. "Text"]:SetText(checkButton:GetText());
    Equi_NotepadSetCheck();
end

function Equi_NotepadSetCheck()
	Equi_Notepad_INITIALISED = Equi_Notepad_INITIALISED + 1;
	
	-- make sure checkbutton exists and variables have been loaded
	if Equi_Notepad_INITIALISED == 2 then
		NotepadCheckButton:SetChecked(EQUI_SHOW_ICON);
		Equi_NotepadIcon();
	end
end

function Equi_NotepadButton_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		Equi_Notepad_PLAYERNAME = UnitName("player");
		
		EQUI_SHARED_TEXT = tostring(EQUI_SHARED_TEXT);
		if EQUI_SHARED_TEXT == "nil" then
			EQUI_SHARED_TEXT = "";
		end
		
		EQUI_CHAR_TEXT = tostring(EQUI_CHAR_TEXT);
		if EQUI_CHAR_TEXT == "nil" then
			EQUI_CHAR_TEXT = "";
		end
		
		-- add notification message
		--EQUI_NOTIFY = nil
		if EQUI_NOTIFY == nil then
			EQUI_NOTIFY = 1;
			EQUI_SHARED_TEXT = EN_Note .. EQUI_SHARED_TEXT;
			EQUI_CHAR_TEXT = EN_Note .. EQUI_CHAR_TEXT;
		end
		
		-- set gadgets
		Equi_NotepadUpdatePage();
		Equi_NotepadSetText();
		
		-- set icon
		if EQUI_INITIALISED == nil then
			-- first run of addon, set defaults
			EQUI_INITIALISED = true;
			EQUI_SHOW_ICON = true;
		end
		
		Equi_NotepadSetCheck();
		
    elseif event == "PLAYER_LEAVING_WORLD" then
       Equi_NotepadStoreText(false);
    end
end

function Equi_NotepadButton_OnClick()
	Equi_NotepadToggleView();
end

function Equi_NotepadUpdateScroller()
	-- return true if scroll can be updated, otherwise it clears flag
	if (Equi_Notepad_IGNORE_UPDATE) then
		Equi_Notepad_IGNORE_UPDATE = false;
		return false;
	else
		return true;
	end
end

function Equi_NotepadSetFocus()
	if EQUI_USE_SHARED then
		Equi_NotepadTextAreaSEditBox:SetFocus();
	else
		Equi_NotepadTextAreaCEditBox:SetFocus();
	end
end


-------------------------------------------------
-- button triggered actions
-------------------------------------------------

function Equi_NotepadToggleView(ldb)
	if ldb == 1 then
		Equi_Notepad_LDB = 1;
	else
		Equi_Notepad_LDB = 0;
	end
	
	if(Equi_NotepadForm:IsVisible()) then
		Equi_NotepadSave();
	else
		Equi_Notepad_Macro = 1;
		Equi_NotepadUpdatePage();
		Equi_NotepadForm:Show();
		Equi_NotepadSetFocus();
	end
end

function Equi_NotepadTogglePage()
	-- toggle
	if EQUI_USE_SHARED then
		EQUI_USE_SHARED = false;
	else
		EQUI_USE_SHARED = true;
	end
	
	PlaySound("igQuestListOpen");
	
	-- show page content
	Equi_NotepadUpdatePage();
	Equi_NotepadSetFocus();
end

function Equi_NotepadSave()
	-- save text and hide window
	Equi_NotepadStoreText(true);
	Equi_NotepadForm:Hide();
end

function Equi_NotepadIcon()
	-- toggle main icon button
	EQUI_SHOW_ICON = NotepadCheckButton:GetChecked();
	
	if EQUI_SHOW_ICON then
		Equi_NotepadButton:Show();
	else
		Equi_NotepadButton:Hide();
		if Equi_Notepad_LDB == 0 then
			if Equi_Notepad_Macro == 1 then
				-- only show message once per window session
				Equi_Notepad_Macro = 0;
				print("Notepad icon hidden: Use /notes or macro to toggle window");
			end
			
			if GetMacroIndexByName("Notepad") == 0 then
				CreateMacro("Notepad", "INV_Misc_Book_08", "/notes", false, false);
			
				if GetMacroIndexByName("Notepad") ~= 0 then
					print("Notepad macro created");
				end
			end
		end
	end
end

function Equi_NotepadCancel()
	-- revert to previous text and hide window
	Equi_NotepadSetText();
	Equi_NotepadForm:Hide();
end


-------------------------------------------------
-- text functions
-------------------------------------------------

function Equi_NotepadUpdatePage()
	-- set current page name & contents
	if EQUI_USE_SHARED then
		Equi_NotepadPageName:SetText("Page: Shared notes");
		Equi_NotepadTextAreaS:Show()
		Equi_NotepadTextAreaC:Hide()
	else
		Equi_NotepadPageName:SetText("Page: " .. Equi_Notepad_PLAYERNAME .. "'s notes");
		Equi_NotepadTextAreaC:Show()
		Equi_NotepadTextAreaS:Hide()
	end
end

function Equi_NotepadSetText()
	-- set editbox text from saved vars
	Equi_NotepadTextAreaSEditBox:SetText(EQUI_SHARED_TEXT);
	Equi_NotepadTextAreaCEditBox:SetText(EQUI_CHAR_TEXT);
	
	Equi_Notepad_IGNORE_UPDATE = true;		-- do not update scroller
end

function Equi_NotepadStoreText(playSoundFx)
	-- save text to stored var
	EQUI_SHARED_TEXT = Equi_NotepadTextAreaSEditBox:GetText();
	EQUI_CHAR_TEXT = Equi_NotepadTextAreaCEditBox:GetText();
	
	if playSoundFx then
		PlaySound("WriteQuest");
	end
end

